searchNodes=[{"doc":"Sorts a list of maps per a list of sort specs. Also supports: keywords structs implementing the Access behaviour nested maps, keywords or structs implementing the Access behaviour","ref":"MapSorter.html","title":"MapSorter","type":"module"},{"doc":"Sorts maps per the given sort_specs . Examples of sort specs for flat data structures: - implicit : [ :dob , :name ] - mixed : [ :dob , desc : :name ] - explicit : [ asc : :dob , desc : :name ] Examples of sort specs with a Date key for flat data structures: - implicit : [ { :dob Date } , :name ] - mixed : [ { :dob Date } , desc : :name ] - explicit : [ asc : { :dob Date } , desc : :name ] Examples of sort specs for nested data structures: - implicit : [ [ :birth , :date ] , :name ] - mixed : [ [ :birth , :date ] , desc : :name ] - explicit : [ asc : [ :birth , :date ] , desc : :name ] Examples of sort specs with a Date key for nested data structures: - implicit : [ { [ :birth , :date ] , Date } , :name ] - mixed : [ { [ :birth , :date ] , Date } , desc : :name ] - explicit : [ asc : { [ :birth , :date ] , Date } , desc : :name ] Examples iex&gt; require MapSorter iex&gt; people = [ ...&gt; %{ name : &quot;Mike&quot; , likes : &quot;movies&quot; , dob : &quot;1992-04-15&quot; } , ...&gt; %{ name : &quot;Mary&quot; , likes : &quot;travels&quot; , dob : &quot;1992-04-15&quot; } , ...&gt; %{ name : &quot;Bill&quot; , likes : &quot;karate&quot; , dob : &quot;1977-08-28&quot; } , ...&gt; %{ name : &quot;Joe&quot; , likes : &quot;boxing&quot; , dob : &quot;1977-08-28&quot; } , ...&gt; %{ name : &quot;Jill&quot; , likes : &quot;cooking&quot; , dob : &quot;1976-09-28&quot; } ...&gt; ] iex&gt; sort_specs = Tuple . to_list ( { :dob , { :desc , :likes } } ) iex&gt; sorted_people = %{ ...&gt; explicit : MapSorter . sort ( people , asc : :dob , desc : :likes ) , ...&gt; mixed : MapSorter . sort ( people , [ :dob , desc : :likes ] ) , ...&gt; runtime : MapSorter . sort ( people , sort_specs ) ...&gt; } iex&gt; sorted_people . explicit == sorted_people . mixed and ...&gt; sorted_people . explicit == sorted_people . runtime and ...&gt; sorted_people . explicit [ %{ name : &quot;Jill&quot; , likes : &quot;cooking&quot; , dob : &quot;1976-09-28&quot; } , %{ name : &quot;Bill&quot; , likes : &quot;karate&quot; , dob : &quot;1977-08-28&quot; } , %{ name : &quot;Joe&quot; , likes : &quot;boxing&quot; , dob : &quot;1977-08-28&quot; } , %{ name : &quot;Mary&quot; , likes : &quot;travels&quot; , dob : &quot;1992-04-15&quot; } , %{ name : &quot;Mike&quot; , likes : &quot;movies&quot; , dob : &quot;1992-04-15&quot; } ]","ref":"MapSorter.html#sort/2","title":"MapSorter.sort/2","type":"macro"},{"doc":"A compare function and a heredoc to become a compare function.","ref":"MapSorter.Compare.html","title":"MapSorter.Compare","type":"module"},{"doc":"Generates an Enum.sort/2 compare function from a list of sort specs. Examples iex&gt; alias MapSorter.Compare iex&gt; sort_specs = [ :dob , desc : :likes ] iex&gt; fun = Compare . fun ( sort_specs ) iex&gt; is_function ( fun , 2 ) true # Compare function always true =&gt; no reordering... iex&gt; alias MapSorter.Compare iex&gt; sort_specs = { :dob , desc : :likes } iex&gt; fun = Compare . fun ( sort_specs ) iex&gt; is_function ( fun , 2 ) and fun . ( 1 , 2 ) and fun . ( :any , &#39;any&#39; ) true iex&gt; alias MapSorter.Compare iex&gt; sort_specs = fn -&gt; [ :dob , desc : :likes ] end iex&gt; fun = Compare . fun ( sort_specs . ( ) ) iex&gt; is_function ( fun , 2 ) true iex&gt; alias MapSorter.Compare iex&gt; sort_specs = Tuple . to_list ( { :dob , { :desc , :likes } } ) iex&gt; fun = Compare . fun ( sort_specs ) iex&gt; is_function ( fun , 2 ) true","ref":"MapSorter.Compare.html#fun/1","title":"MapSorter.Compare.fun/1","type":"function"},{"doc":"Generates a cond/1 expression as a heredoc to become a compare function. The heredoc may be converted into its quoted form at compile time or else have its contents evaluated at runtime. This function cannot be named cond as it is among the Kernel.SpecialForms . Examples iex&gt; alias MapSorter.Compare iex&gt; Compare . heredoc ( [ ] ) &quot;&quot;&quot; &amp; cond do true -&gt; true or &amp;1 * &amp;2 end &quot;&quot;&quot; iex&gt; alias MapSorter.Compare iex&gt; sort_specs = [ :name , { :desc , :dob } ] iex&gt; Compare . heredoc ( sort_specs ) &quot;&quot;&quot; &amp; cond do &amp;1[:name] &lt; &amp;2[:name] -&gt; true &amp;1[:name] &gt; &amp;2[:name] -&gt; false &amp;1[:dob] &gt; &amp;2[:dob] -&gt; true &amp;1[:dob] &lt; &amp;2[:dob] -&gt; false true -&gt; true or &amp;1 * &amp;2 end &quot;&quot;&quot; iex&gt; alias MapSorter.Compare iex&gt; sort_specs = [ :name , { :desc , { :dob , Date } } ] iex&gt; Compare . heredoc ( sort_specs ) &quot;&quot;&quot; &amp; cond do &amp;1[:name] &lt; &amp;2[:name] -&gt; true &amp;1[:name] &gt; &amp;2[:name] -&gt; false &amp;1[:dob] != nil and Date.compare(&amp;1[:dob], &amp;2[:dob]) == :gt -&gt; true &amp;1[:dob] != nil and Date.compare(&amp;1[:dob], &amp;2[:dob]) == :lt -&gt; false true -&gt; true or &amp;1 * &amp;2 end &quot;&quot;&quot; iex&gt; alias MapSorter.Compare iex&gt; sort_specs = [ :name , { :desc , { :account , Path } } ] iex&gt; Compare . heredoc ( sort_specs ) &quot;&quot;&quot; &amp; cond do &amp;1[:name] &lt; &amp;2[:name] -&gt; true &amp;1[:name] &gt; &amp;2[:name] -&gt; false &amp;1[{:account, Path}] &gt; &amp;2[{:account, Path}] -&gt; true &amp;1[{:account, Path}] &lt; &amp;2[{:account, Path}] -&gt; false true -&gt; true or &amp;1 * &amp;2 end &quot;&quot;&quot;","ref":"MapSorter.Compare.html#heredoc/1","title":"MapSorter.Compare.heredoc/1","type":"function"},{"doc":"Compare function","ref":"MapSorter.Compare.html#t:comp_fun/0","title":"MapSorter.Compare.comp_fun/0","type":"type"},{"doc":"Generates cond/1 clauses as a heredoc from a list of sort specs.","ref":"MapSorter.Cond.html","title":"MapSorter.Cond","type":"module"},{"doc":"Generates cond/1 clauses as a heredoc from a list of sort specs. Examples iex&gt; alias MapSorter.Cond iex&gt; sort_specs = [ :name , { :desc , :dob } ] iex&gt; Cond . clauses ( sort_specs ) &quot;&quot;&quot; &amp;1[:name] &lt; &amp;2[:name] -&gt; true &amp;1[:name] &gt; &amp;2[:name] -&gt; false &amp;1[:dob] &gt; &amp;2[:dob] -&gt; true &amp;1[:dob] &lt; &amp;2[:dob] -&gt; false &quot;&quot;&quot; iex&gt; alias MapSorter.Cond iex&gt; sort_specs = [ :name , { :desc , { :dob , Date } } ] iex&gt; Cond . clauses ( sort_specs ) &quot;&quot;&quot; &amp;1[:name] &lt; &amp;2[:name] -&gt; true &amp;1[:name] &gt; &amp;2[:name] -&gt; false &amp;1[:dob] != nil and Date.compare(&amp;1[:dob], &amp;2[:dob]) == :gt -&gt; true &amp;1[:dob] != nil and Date.compare(&amp;1[:dob], &amp;2[:dob]) == :lt -&gt; false &quot;&quot;&quot; iex&gt; alias MapSorter.Cond iex&gt; sort_specs = [ :name , { :desc , { :dob , String } } ] iex&gt; Cond . clauses ( sort_specs ) &quot;&quot;&quot; &amp;1[:name] &lt; &amp;2[:name] -&gt; true &amp;1[:name] &gt; &amp;2[:name] -&gt; false &amp;1[{:dob, String}] &gt; &amp;2[{:dob, String}] -&gt; true &amp;1[{:dob, String}] &lt; &amp;2[{:dob, String}] -&gt; false &quot;&quot;&quot;","ref":"MapSorter.Cond.html#clauses/1","title":"MapSorter.Cond.clauses/1","type":"function"},{"doc":"","ref":"MapSorter.Log.html","title":"MapSorter.Log","type":"module"},{"doc":"","ref":"MapSorter.Log.html#debug/2","title":"MapSorter.Log.debug/2","type":"function"},{"doc":"","ref":"MapSorter.Log.html#warn/2","title":"MapSorter.Log.warn/2","type":"function"},{"doc":"","ref":"MapSorter.Regex.html","title":"MapSorter.Regex","type":"module"},{"doc":"Compares two regex structs.","ref":"MapSorter.Regex.html#compare/2","title":"MapSorter.Regex.compare/2","type":"function"},{"doc":"Defines sort spec types and generates square brackets access syntax strings.","ref":"MapSorter.SortSpec.html","title":"MapSorter.SortSpec","type":"module"},{"doc":"Generates a square brackets access syntax string from a sort spec key . Examples iex&gt; import MapSorter.SortSpec , only : [ brackets : 1 ] iex&gt; brackets ( [ :birth , :date ] ) &quot;[:birth][:date]&quot; iex&gt; import MapSorter.SortSpec , only : [ brackets : 1 ] iex&gt; brackets ( [ :address , &#39;city&#39; , :state ] ) &quot;[:address][&#39;city&#39;][:state]&quot; iex&gt; import MapSorter.SortSpec , only : [ brackets : 1 ] iex&gt; brackets ( [ :dob ] ) &quot;[:dob]&quot; iex&gt; import MapSorter.SortSpec , only : [ brackets : 1 ] iex&gt; brackets ( :dob ) &quot;[:dob]&quot; iex&gt; import MapSorter.SortSpec , only : [ brackets : 1 ] iex&gt; brackets ( &#39;dob&#39; ) &quot;[&#39;dob&#39;]&quot; iex&gt; import MapSorter.SortSpec , only : [ brackets : 1 ] iex&gt; brackets ( [ 1 , &lt;&lt; 1 , 2 , 3 &gt;&gt; , 3.14 , &#39;dob&#39; ] ) &quot;[1][&lt;&lt;1, 2, 3&gt;&gt;][3.14][&#39;dob&#39;]&quot; iex&gt; import MapSorter.SortSpec , only : [ brackets : 1 ] iex&gt; brackets ( [ &#39;dob&#39; , &#39;3.14&#39; , 3.14 , 0 , { 1 , 2 } , :likes ] ) &quot;[&#39;dob&#39;][&#39;3.14&#39;][3.14][0][{1, 2}][:likes]&quot;","ref":"MapSorter.SortSpec.html#brackets/1","title":"MapSorter.SortSpec.brackets/1","type":"function"},{"doc":"Sort spec key","ref":"MapSorter.SortSpec.html#t:key/0","title":"MapSorter.SortSpec.key/0","type":"type"},{"doc":"Sort direction","ref":"MapSorter.SortSpec.html#t:sort_dir/0","title":"MapSorter.SortSpec.sort_dir/0","type":"type"},{"doc":"Sort spec","ref":"MapSorter.SortSpec.html#t:t/0","title":"MapSorter.SortSpec.t/0","type":"type"},{"doc":"Converts the AST of sort specs into the AST of an Enum.sort/2 compare function.","ref":"MapSorter.SortSpecs.html","title":"MapSorter.SortSpecs","type":"module"},{"doc":"Converts sort_specs into the AST of an Enum.sort/2 compare function. Examples # Compile time sort specs... iex&gt; alias MapSorter.SortSpecs iex&gt; sort_specs = [ :dob ] iex&gt; { :ok , comp_fun_ast } = SortSpecs . to_quoted ( sort_specs ) iex&gt; { :&amp; , _meta , [ args ] } = comp_fun_ast iex&gt; { comp_fun , [ ] } = Code . eval_quoted ( comp_fun_ast ) iex&gt; is_function ( comp_fun , 2 ) and Macro . to_string ( args ) &quot;&quot;&quot; cond do &amp;1[:dob] &lt; &amp;2[:dob] -&gt; true &amp;1[:dob] &gt; &amp;2[:dob] -&gt; false true -&gt; true or &amp;1 * &amp;2 end &quot;&quot;&quot; |&gt; String . trim_trailing ( ) # Compile time sort specs... iex&gt; alias MapSorter.SortSpecs iex&gt; sort_specs = fn -&gt; [ desc : :dob , asc : :bmi ] end iex&gt; { :ok , comp_fun_ast } = sort_specs . ( ) |&gt; SortSpecs . to_quoted ( ) iex&gt; { :&amp; , _meta , [ args ] } = comp_fun_ast iex&gt; { comp_fun , [ ] } = Code . eval_quoted ( comp_fun_ast ) iex&gt; is_function ( comp_fun , 2 ) and Macro . to_string ( args ) &quot;&quot;&quot; cond do &amp;1[:dob] &gt; &amp;2[:dob] -&gt; true &amp;1[:dob] &lt; &amp;2[:dob] -&gt; false &amp;1[:bmi] &lt; &amp;2[:bmi] -&gt; true &amp;1[:bmi] &gt; &amp;2[:bmi] -&gt; false true -&gt; true or &amp;1 * &amp;2 end &quot;&quot;&quot; |&gt; String . trim_trailing ( ) # Compile time sort specs... iex&gt; alias MapSorter.SortSpecs iex&gt; sort_specs = [ :dob , desc : :likes ] iex&gt; { :ok , comp_fun_ast } = SortSpecs . to_quoted ( sort_specs ) iex&gt; { :&amp; , _meta , [ args ] } = comp_fun_ast iex&gt; { comp_fun , [ ] } = Code . eval_quoted ( comp_fun_ast ) iex&gt; is_function ( comp_fun , 2 ) and Macro . to_string ( args ) &quot;&quot;&quot; cond do &amp;1[:dob] &lt; &amp;2[:dob] -&gt; true &amp;1[:dob] &gt; &amp;2[:dob] -&gt; false &amp;1[:likes] &gt; &amp;2[:likes] -&gt; true &amp;1[:likes] &lt; &amp;2[:likes] -&gt; false true -&gt; true or &amp;1 * &amp;2 end &quot;&quot;&quot; |&gt; String . trim_trailing ( ) # Runtime sort specs... iex&gt; alias MapSorter.SortSpecs iex&gt; sort_specs = quote do : Tuple . to_list ( { :dob , { :desc , :likes } } ) iex&gt; { :ok , comp_fun_ast } = SortSpecs . to_quoted ( sort_specs ) iex&gt; { { :. , _ , nested_args } , _meta , [ args ] } = comp_fun_ast iex&gt; { comp_fun , [ ] } = Code . eval_quoted ( comp_fun_ast ) iex&gt; is_function ( comp_fun , 2 ) and ...&gt; { Macro . to_string ( nested_args ) , Macro . to_string ( args ) } { &quot;[MapSorter.Compare, :fun]&quot; , &quot;Tuple.to_list({:dob, {:desc, :likes}})&quot; }","ref":"MapSorter.SortSpecs.html#to_quoted/1","title":"MapSorter.SortSpecs.to_quoted/1","type":"function"},{"doc":"A list of sort specs","ref":"MapSorter.SortSpecs.html#t:t/0","title":"MapSorter.SortSpecs.t/0","type":"type"},{"doc":"","ref":"MapSorter.TestSetup.html","title":"MapSorter.TestSetup","type":"module"},{"doc":"","ref":"MapSorter.TestSetup.html#setup_all/1","title":"MapSorter.TestSetup.setup_all/1","type":"function"},{"doc":"","ref":"MapSorter.TestSetup.Person.html","title":"MapSorter.TestSetup.Person","type":"module"},{"doc":"Callback implementation for Access.fetch/2 .","ref":"MapSorter.TestSetup.Person.html#fetch/2","title":"MapSorter.TestSetup.Person.fetch/2","type":"function"},{"doc":"Callback implementation for Access.get_and_update/3 .","ref":"MapSorter.TestSetup.Person.html#get_and_update/3","title":"MapSorter.TestSetup.Person.get_and_update/3","type":"function"},{"doc":"Callback implementation for Access.pop/2 .","ref":"MapSorter.TestSetup.Person.html#pop/2","title":"MapSorter.TestSetup.Person.pop/2","type":"function"}]